#!/usr/bin/perl -w

use strict;

my $MIN_TIME = 5500;
my $MAX_TIME = 5520;
my $nthreads = -1;

my $str = "";

while (my $line = <STDIN>) {

    if ($line =~ /^numthreads: ([0-9]+)$/) {
	$nthreads = $1;
    }

    if ($line =~ /^tracerec: ([0-9]+) ([0-9\.]+) ([0-9\.]+) [0-9\.]+ [0-9\.]+$/) {
	
	my $thread = $1;
	my $start = $2;
	my $end = $3;
	
	next if ($end < $MIN_TIME);
	next if ($start > $MAX_TIME);

	if ($start < $MIN_TIME) {
	    $start = $MIN_TIME;
	}

	if ($end > $MAX_TIME) {
	    $end = $MAX_TIME;
	}

	my $nthread = $thread+1;
		
	$str .= "newline poly linethickness 0.5 pfill 0.8 pts\n";
	$str .= "  $start $thread\n";
	$str .= "  $end $thread\n";
	$str .= "  $end $nthread\n";
	$str .= "  $start $nthread\n\n";
    }
}

print "newgraph\n";
print "xaxis label : Time (ms)\n";
print "yaxis label : Thread Number\n";
print "  min 0\n";
print "  max $nthreads\n";
print "  hash 0\n";

for (my $i=0; $i<$nthreads; $i++) {
    print "  hash_label at ".($i+0.5)." : $i\n";
}

print $str;
