#include "hourglass.h"

static void print_results_lat (int id) 
{
  int j;
  sec_time dur;

  fprintf (stdout, "microseconds late\n");
  for (j=0; j<thrd_data[id].lat_slot; j++) {
    fprintf (stdout, "latlate: %f\n", 
	     cycle_to_us(thrd_data[id].lat_slots[j]));
  }
  dur = cycle_to_sec (end - start);
  fprintf (stderr, "%d slots filled; %f per second\n", 
	   thrd_data[id].lat_slot, 
	   thrd_data[id].lat_slot / dur);
}

static void print_results_trace (int id)
{
}

static void print_trace_recs (void)
{
  int i, j;
  cycle_time trace_start = ((long long int)1)<<60;
  cycle_time trace_end = 0;
  cycle_time dur;
  cycle_time total_thr_time = 0;
 
  for (i=0; i<current_record; i++) {
    if (trace_start > trace_recs[i].start &&
	trace_recs[i].start != 0) {
      trace_start = trace_recs[i].start;
    }
    if (trace_end < trace_recs[i].end &&
	trace_recs[i].end != 0) {
      trace_end = trace_recs[i].end;
    }
  }

  printf ("in cycles, trace start %lld, end %lld\n", trace_start, trace_end);

  dur = trace_end - trace_start;
  printf ("trace duration %f seconds\n", cycle_to_sec (dur));

  for (j=0; j<num_threads; j++) {
    thrd_data[j].thread_time = 0;
    for (i=0; i<current_record; i++) {
      if (trace_recs[i].id == j && trace_recs[i].end != 0) {
	thrd_data[j].thread_time += trace_recs[i].end - trace_recs[i].start;
      }
    }
    printf ("thread %d recorded %f seconds\n", 
	    j, cycle_to_sec (thrd_data[j].thread_time));
    total_thr_time += thrd_data[j].thread_time;
  }
  printf ("total thread time %f seconds\n", cycle_to_sec (total_thr_time));

  printf ("\ntime slots in ms: thread start end duration gap:\n");
  for (i=0; i<current_record; i++) {
    if (trace_recs[i].end != 0) {
      printf ("tracerec: %d %f %f %f %f\n",
	      trace_recs[i].id,
	      1000 * cycle_to_sec (trace_recs[i].start - trace_start),
	      1000 * cycle_to_sec (trace_recs[i].end - trace_start),
	      1000 * cycle_to_sec (trace_recs[i].end - trace_recs[i].start),
	      1000 * cycle_to_sec (trace_recs[i].start - trace_recs[i-1].end));
    }
  }

#ifdef GAP_HIST
  printf ("\ngap histogram in cycles:\n");
  for (i=0; i<NUM_GAP_HIST_BUCKETS; i++) {
    printf ("  %d - %d : %d\n",
	    i*GAP_HIST_DIVISOR,
	    (i+1)*GAP_HIST_DIVISOR,
	    gap_hist[i]);
  }
#endif
}
	 
void print_all_results (void)
{
  int i;

  printf ("numthreads: %d\n", num_threads);

  for (i=0; i<num_threads; i++) {
    
    printf ("  *** results for thread %d ***\n", i);

    switch (thrd_data[i].task) {

    case LAT:
      print_results_lat (i);
      break;

    case CPU:
    case YIELD:
    case PERIODIC:
      print_results_trace (i);
      break;

    default:
      printf ("Hrm: unexpected thread task -- aborting\n");
      exit (-1);
    }
  }

  if (tracing) {
    print_trace_recs ();
  }
}

